;http://forums.purebasic.com/english/viewtopic.php?f=13&t=64688&hilit=Dithering%3A&start=0
#PBBlack = $000000:   #PBWhite = $FFFFFF

Procedure.i TruncF0255 (a.f)
  If a > 255: a = 255: ElseIf a < 0: a = 0: EndIf
  ProcedureReturn a
EndProcedure


Procedure RGBtoLum(c.l)  ;Get luminosity (the min and max RGB levels / 2)
  r = (c & $FF) :  g = ((c & $FF00) >> 8) :  b = ((c & $FF0000) >> 16) 
  If g < r: min = g: Else: min = r: EndIf
  If b < min: min = b: EndIf  
  If g > r: max = g: Else: max = r: EndIf
  If b > max: max = b: EndIf   
  lum = (max + min) >> 1  ;/ 2.0
  ProcedureReturn lum
EndProcedure



;Sierra-2-4A aka Sierra Lite     
;         *   2           =            *     0.5
;     1   1     (1/4)          0.25  0.25

Procedure SierraLiteDIRECT(hImg)
  Protected nextpixel.f, ierror.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg)
  For y = 2 To height-3                     ;completely avoid the edges to keep it simple for this test
    For x = 2 To width-3
      oldpixel = RGBtoLum(Point(x,y))
      If oldpixel < 128
        newpixel = 0
        Plot(x,y, #Black)
      Else
        newpixel = 255
        Plot(x,y, #White)
      EndIf
      quant_error.f = oldpixel - newpixel
      newx.f = TruncF0255(RGBtoLum(Point(x+1,y))   + (0.5  * quant_error))  ;2/4
      Plot(x+1,y, RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x-1,y+1)) + (0.25 * quant_error))  ;1/4
      Plot(x-1,y+1, RGB(newx,newx,newx))
      newx.f = TruncF0255(RGBtoLum(Point(x,y+1))   + (0.25 * quant_error))  ;1/4
      Plot(x,y+1,  RGB(newx,newx,newx))
    Next x
  Next y
  StopDrawing()
EndProcedure


Procedure SierraLiteARRAY(hImg)
  Protected nextpixel.f, oldpixel.f
  StartDrawing(ImageOutput(hImg))
  width = ImageWidth(hImg): height = ImageHeight(hImg)
  Dim error(width+5,height+5)  ;An error(x,y) for every pixel
  For y = 2 To height-3                     ;completely avoid the edges to keep it simple for this test
    For x = 2 To width-3
      oldpixel = Truncf0255(RGBtoLum(Point(x,y)) + error(x,y)) 
      If oldpixel < 128
        newpixel = 0
        Plot(x,y, #PBBlack)
      Else
        newpixel = 255
        Plot(x,y, #PBWhite)
      EndIf      
      quant_error.f = oldpixel - newpixel
      error(x+1,y)   + (0.5  * quant_error)  ;2/4
      error(x-1,y+1) + (0.25 * quant_error)  ;1/4
      error(x,y+1)   + (0.25 * quant_error)  ;1/4
    Next x
  Next y
  StopDrawing()
EndProcedure


Procedure CountBW(hImg)
  StartDrawing(ImageOutput(hImg))
  For y = 0 To ImageHeight(hImg)-1
    For x = 0 To ImageWidth(hImg)-1
      If Point(x,y) = 0: B + 1: Else: W + 1: EndIf
    Next x
  Next y
  StopDrawing()
  Debug("Black=" + Str(B) + "  White=" + Str(W))
EndProcedure


UsePNGImageDecoder():  UseJPEGImageDecoder()
;If LoadImage(0, "C:\temp\Cube.jpg") = 0
;If LoadImage(0, "lena.bmp") = 0
If LoadImage(0, "girl.jpg") = 0
  MessageRequester("Fail","Loadimage failed"): End
EndIf
If OpenWindow(0, 0, 0, ImageWidth(0)*2, ImageHeight(0)+10, "Sierra Lite Test", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  hCopy = CopyImage(0,#PB_Any) 
  
  SierraLiteDIRECT(hCopy)
  ;SierraLiteARRAY(hCopy)
  
  hTrim = GrabImage(hCopy, #PB_Any, 2,2,ImageWidth(0)-4,ImageHeight(0)-4)  ;for simplicity we're ignoring edges for this test
  CountBW(hTrim)
  ;SaveImage(hTrim,"c:\temp\CubeDirect.bmp")
  
  ImageGadget(0, 0, 0, 200, 200, ImageID(0))  
  ImageGadget(1, ImageWidth(0), 0, 200, 200, ImageID(hTrim))
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 92
; FirstLine = 67
; Folding = -
; EnableUnicode
; EnableXP